/**
 * Copyright (c) 2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.cli.extension.bcgateway.mock;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.ow2.petals.basisapi.exception.PetalsException;
import org.ow2.petals.binding.gateway.clientserver.api.AdminService;

/**
 * A mock of {@link AdminService} for unit testing
 * 
 * @author Christophe DENEUX - Linagora
 *
 */
public class PetalsBcGatewayInstallationMock implements AdminService {

    private Map<String, Integer> transportListeners = new HashMap<>();

    @Override
    public void addTransportListener(final String id, final int port) throws PetalsException {
        this.transportListeners.put(id, port);
    }

    @Override
    public void setTransportListenerPort(final String id, final int port) throws PetalsException {
        this.transportListeners.put(id, port);
    }

    @Override
    public Map<String, Object[]> getTransportListeners() {
        final Map<String, Object[]> res = new HashMap<>();
        for (final Entry<String, Integer> e : this.transportListeners.entrySet()) {
            res.put(e.getKey(), new Object[] { e.getValue(), false, "" });
        }
        return res;
    }

    @Override
    public Boolean removeTransportListener(final String id) throws PetalsException {
        return this.transportListeners.remove(id) != null;
    }

}
